<template>
  <div class="toggle-container" @click="unsubscribeUser" v-if="isSubscribed">
    <div class="tooltip" v-if="hovered">
      Haz click para cancelar la suscripción
    </div>
    <div @mouseover="hovered = true" @mouseleave="hovered = false">
      <img :src="lpLogo" alt="Cancelar suscripcion">
    </div>
  </div>
</template>

<script lang="ts">
import webPushService from '@/services/webPush/webPushService';
import lpLogo from '@/assets/lp-dark.png';

export default {
  name: 'unsubscribe-button',
  data() {
    return {
      hovered: false,
      lpLogo
    }
  },
  props: {
    subscription: PushSubscription
  },
  computed: {
    isSubscribed() {
      return this.subscription !== null;
    }
  },
  methods: {
    async unsubscribeUser() {
      try {
        if (!this.subscription) return;

        await this.subscription.unsubscribe();
        await webPushService.unsubscribe(this.subscription);
        this.$emit("unsubscribed");
      } catch (error) {
        alert(`Error al cancelar la suscripción: ${error}`);
      }
    }
  }
}
</script>

<style scoped>
.toggle-container {
  position: fixed;
  bottom: 20px;
  right: 20px;
  cursor: pointer;
  z-index: 1000;
}

.tooltip {
  position: absolute;
  bottom: 40px;
  right: -10px;
  background-color: #333;
  color: #fff;
  padding: 5px 10px;
  border-radius: 4px;
  font-size: 14px;
  white-space: nowrap;
}

img {
  width: 40px;
  height: 40px;
}
</style>
